// WinHonMain.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Winhontest.h"
#include "WinHonMain.h"
#include "socketx.h"
#include "tranchar.h"
#include "HonyakuSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// WinHonMain _CAO


WinHonMain::WinHonMain(CWnd* pParent /*=NULL*/)
	: CDialog(WinHonMain::IDD, pParent)
{
	//{{AFX_DATA_INIT(WinHonMain)
	m_srcDocumentMessage = _T("");
	m_dstDocumentMessage = _T("");
	//}}AFX_DATA_INIT
}


void WinHonMain::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(WinHonMain)
	DDX_Control(pDX, IDC_BUTTON4, m_korekkiriButton);
	DDX_Text(pDX, IDC_EDIT1, m_srcDocumentMessage);
	DDX_Text(pDX, IDC_EDIT2, m_dstDocumentMessage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(WinHonMain, CDialog)
	//{{AFX_MSG_MAP(WinHonMain)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_EN_CHANGE(IDC_EDIT2, OnChangeEdit2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

int		ejCounterFlag = 0;			//pꁨ{ϊ̎{
int		jeCounterFlag = 0;			//{ꁨpϊ̎{

int		honyakuCounterFlag = 0;		// 
int		honyakuTimerCouter = 0;		// ACh
BOOL	realInitFlag = TRUE;		// 
BOOL	passedOnTimerFlag = FALSE;	

bool	ejShowFlag = false;			

const char* HonyakuError(int ErrCode)
{
	const char *err;

	if ( ((ErrCode >= -204) && (ErrCode <= -100)) || (ErrCode == -208))
	{
		err = "T[oŒvIG[A|T[oI܂B܂ T[oŃG[A|T[oƂ̐ڑ؂܂B";
		return err;
	}

	if ((ErrCode >= -4039) && (ErrCode <= -4020))
	{
		err = "VXe̐ݒ肪ł܂łBRs[^pꎫ̐ݒ肪ł܂łBwK̐ݒ肪ł܂łB̂ꂩ̃bZ[WY܂";
		return err;
	}


	switch(ErrCode)
	{
	case -206  : err = "܂͖󕶂܂BZ؂čĖ|󂵂ĂB"; 	break;
	case -300  : err = "T[oƐڑł܂łB";	break;
	case -500  : err ="EBhẼTCY߂܂B";	break;
	case -501  : err ="T[oƂ̒ʐMŒvIG[܂B";	break;
	case -502  : err ="w肳ꂽʒuɂ͒Pꂪ݂܂B";	break;
	case -503  : err ="₪܂B";	break;
	case -600  : err ="CZX擾ł܂łB";	break;
	case -1000 : err ="ɗ̈s܂BZ؂čĖ|󂵂ĂB";	break;
	case -1001 : err ="|GWĂяöɌ肪܂B";	break;
	case -1002 : err ="ɗ̈s܂BZ؂čĖ|󂵂ĂB";	break;
	case -1003 : err ="\͂Ɏs܂BCčĖ|󂵂ĂB";	break;
	case -1012 : err ="̂̈ʒuɂ͒Pꂪ݂܂";	break;
	case -2000 : err ="t@C̎wɌ肪܂BB";	break;
	case -2001 : err ="t@C̎wɌ肪܂BB";	break;
	case -2002 : err ="t@C̎wɌ肪܂BB";	break;
	case -2003 : err ="t@C̎wɌ肪܂BB";	break;
	case -2004 : err ="t@C̎wɌ肪܂BB";	break;
	case -2013 : err ="t@C̎wɌ肪܂BB";	break;
	case -2015 : err ="t@C̎wɌ肪܂BB";	break;
	case -2016 : err ="t@C̎wɌ肪܂BB";	break;
	case -2017 : err ="t@C̎wɌ肪܂BB";	break;
	case -3000 : err ="|ŎԂ߂ă^CAEg܂B";	break;
	case -3002 : err ="t@C̃wb_[Ɉُ킪܂B";	break;
	case -3003 : err ="t@C̃o[WɈُ킪܂B";	break;
	case -3004 : err ="ꃆ[ŮwK̃bNŃ^CAEg܂B";	break;
	case -4000 : err ="܂͖󕶂܂BZ؂čĖ|󂵂ĂB";	break;
	case -4002 : err ="|󌋉ʂ܂Bpꎫ̐ݒmFĂB";	break;
	case -4003 : err ="|󌋉ʂ܂Bpꎫ̐ݒmFĂB";	break;
	case -4004 : err ="܂|󂳂Ă܂B";	break;
	case -4010 : err ="VXe̓ǂݍ݂ł܂B";	break;
	case -4012 : err ="wK̓ǂݍ݁A܂͏݂ł܂B";	break;
	case -4013 : err ="pꎫ̓ǂݍ݂ł܂B"; break;
	case -4016 : err ="Ɏw肵Pꂪ܂B";	break;
	case -4017 : err ="̓ǂݍ݂ł܂łB";	break;
	case -9998 : err ="|GWŁAVXeG[܂B";	break;
	case -9999 : err ="|GWŒvIG[A|T[oI܂B";	break;

	default:
		err = "s̃G[܂B";
	}

	return err;
}

void WinHonMain::HonGetStatus(void)
{
	if (!theSocket.Create())
	{
		AfxMessageBox("\Pbg쐬ł܂łB");
		return; // IɂẮAōl
	}
		
	// RlNVm
	if (!theSocket.Connect(theSocket.m_HonyakuServer, 2744))
	{
		AfxMessageBox("T[oւ̃RlNVɎs܂B");
		return; // IɂẮAōl
	}


	INT32 honHead[20];			// |󍰃wb_bZ[W͗pobt@
	memset(honHead, 0, sizeof(INT32) * 20);
	INT32 honDataLength = 0;	// |󍰃bZ[Wf[^
	INT32 int32Length = 4;		// INT32̃oCg(=4)	
	
	honHead[0] = htonl(SEND_ID);
	honDataLength = int32Length * 2;	
	honHead[1] = htonl(honDataLength);			// 0x00000008
	honHead[2] = htonl(TRNS_GET_STATUS);		// 0x00f0001a
	honHead[3] = htonl(1);						// 1

	// bZ[W̑M
	// int32Length * 2 ́AhonHead[0],honHead[1]̕
	theSocket.Send(honHead, int32Length * 2 + honDataLength, 0);

	memset(honHead, 0, sizeof(INT32) * 20);

	// bZ[W̎M
	if (theSocket.Receive(honHead,int32Length * 4, 0) == SOCKET_ERROR)
	{
		AfxMessageBox("bZ[W̎MɎs܂B");		
		return; // IɂẮAōl
	}

	char personCountChar[3];
	int personCount = ntohl(honHead[3]);
	_itoa(personCount,personCountChar,10);


	if ( personCount == 0 )
	{
		m_dstDocumentMessage += "\r\n|󍰃T[oɐڑĂ郆[U͂܂B";
	}
	else
	{
		m_dstDocumentMessage += "\r\nA|󍰃T[o ";
		m_dstDocumentMessage += personCountChar;
		m_dstDocumentMessage += " lڑĂ܂B\r\n";
		m_dstDocumentMessage += "[Uꗗ܂B\r\n\r\n";
	}

	for (int i = 0; i < personCount; i++)
	{
		BYTE dummyByte;	
		
		CString userName;
		userName.Empty();

		while(1)// ꕶMĂB
		{
			dummyByte = 0;
			theSocket.Receive(&dummyByte, 1, 0);
			
			if (dummyByte == 0x00) break;
	
			// ASCIIR[hȂ
			if ((dummyByte > 0x20) & (dummyByte <= 0x7f))
				userName += dummyByte;
		}
		m_dstDocumentMessage += userName;

		CString hostName;
		userName.Empty();

		while(1)// ꕶMĂB
		{
			dummyByte = 0;
			theSocket.Receive(&dummyByte, 1, 0);
			if (dummyByte == 0x00) break;
				// ASCIIR[hȂ
			if ((dummyByte > 0x20) & (dummyByte <= 0x7f))
				hostName += dummyByte;
		}

		m_dstDocumentMessage += " (";
		m_dstDocumentMessage += hostName;
		m_dstDocumentMessage += ",";


		CString ipAddr;
		ipAddr.Empty();

		while(1)// ꕶMĂB
		{
			dummyByte = 0;
			theSocket.Receive(&dummyByte, 1, 0);
			if (dummyByte == 0x00) break;
				// ASCIIR[hȂ
			if ((dummyByte > 0x20) & (dummyByte <= 0x7f))
				ipAddr += dummyByte;
		}

		m_dstDocumentMessage += ipAddr;
		m_dstDocumentMessage += ")";
		m_dstDocumentMessage += "\r\n";		


		for (int k = 0 ; k < 3 ; k++)
		{
			CString dummyMessage;
			do			// ꕶMĂB
			{
				theSocket.Receive(&dummyByte, 1, 0);
				dummyMessage += dummyByte;
			}while( dummyByte != 0x00);
		}

		INT32 dummyHead[13];
		theSocket.Receive(dummyHead,int32Length * 13, 0);
	}


	UpdateData(false);	

	// \Pbg̖IȃN[Y
	theSocket.ShutDown();
	theSocket.Close();
}



void WinHonMain::HonDisconnect(void)
{

	passedOnTimerFlag = TRUE;
	
	INT32 honHead[20];			// |󍰃wb_bZ[W͗pobt@
	memset(honHead, 0, sizeof(INT32) * 20);
	INT32 honDataLength = 0;	// |󍰃bZ[Wf[^
	INT32 int32Length = 4;		// INT32̃oCg(=4)	

	if (jeCounterFlag != 0) // JE[hȏg
	{
		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

		honDataLength = int32Length * 2;	
		honHead[1] = htonl(honDataLength);			// 0x00000008
		honHead[2] = htonl(EG_END);					// 0x00f00002
		honHead[3] = htonl(JE);						// 0x00000002 Japanese->English

		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕
		theSocket.Send(honHead, int32Length * 2 + honDataLength, 0);
		// bZ[W̎MiG[͍sȂj
		theSocket.Receive(honHead,int32Length * 3, 0);	
	}

	if (ejCounterFlag != 0)  // EJ[hȏg
	{
		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd	

		honDataLength = int32Length * 2;
		honHead[1] = htonl(honDataLength);			// 0x00000008
		honHead[2] = htonl(EG_END);					// 0x00f00002
		honHead[3] = htonl(EJ);						// 0x00000001 English->Japanese

		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕
		theSocket.Send(honHead, int32Length * 2 + honDataLength, 0);

		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");		
			return; // IɂẮAōl
		}
	}


	ejCounterFlag = 0;			//pꁨ{ϊ̃Zbg
	jeCounterFlag = 0;			//{ꁨpϊ̃Zbg
	
	// \Pbg̖IȃN[Y
	theSocket.ShutDown();
	theSocket.Close();

	HonGetStatus();
}


/////////////////////////////////////////////////////////////////////////////
// WinHonMain bZ[W nh

void WinHonMain::OnButton1() 
{

	// ̉sR[h󔒂ɕύXAsIȟɋ󔒂ǉ
	m_srcDocumentMessage = theTransChar.eraseELineFeed(m_srcDocumentMessage);

	// ^CAEgԂ̐ݒ 10[b]
	UINT uTimeOut = 10000;

	CString sendMessage; 
	CString recvMessage;

	INT32 honHead[20];			// |󍰃wb_bZ[W͗pobt@
	memset(honHead, 0, sizeof(INT32) * 20);
	INT32 honDataLength = 0;		// |󍰃bZ[Wf[^
	INT32 int32Length = 4;		// INT32̃oCg(=4)


	// pꁨ{ϊ߂čsꍇ́A{
	if (ejCounterFlag == 0)
	{

		//// eg_init(0x00f00001) |GW̏

		// [U̎擾
		char userName[100];
		DWORD userNameLength = 100;
		GetUserName(userName,&userNameLength);
		
		sendMessage = userName;

		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd
		honDataLength = int32Length * 3 + sendMessage.GetLength() + 1;

		honHead[1] = htonl(honDataLength);			// 

		honHead[2] = htonl(EG_INIT);				// 0x00f00001
		honHead[3] = htonl(EJ);						// 0x00000001
		honHead[4] = htonl(0x0000e001);				// dl̎w
		
		// bZ[W̑M
		// int32Length * 5 ́AhonHead[0] - honHead[4]̕
		theSocket.Send(honHead, int32Length * 5, 0);

		theSocket.Send(sendMessage,0,0);	//[ȖM
		BYTE dummyByte;
		theSocket.Send(&dummyByte, 1, 0);	// I[


		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂(EJ EG_INIT)B");		
#if 0
			AfxMessageBox("1");
#endif
			HonDisconnect();
			return;
			// IɂẮAōl
		}

		if (ntohl(honHead[2]) != 0)
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));	
#if 0
			AfxMessageBox("2");
#endif
			HonDisconnect();
			return;
		}
		
		//// eg_setmode(0x00f00011) |GW̃[hݒ
		// í݂A[hŒj

		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

//		honDataLength = int32Length * 2 + 4;
		honDataLength =   int32Length * 2 
						+ theCHonyakuSet.EinichiSet.GetLength()
						+ 1 ;

		honHead[1] = htonl(honDataLength);			// 0x0000000b

		honHead[2] = htonl(EG_SETMODE);				// 0x00f00011
		honHead[3] = htonl(EJ);						// 0x00000001
//		honHead[4] = htonl(0x4b570000);				// |󃂁[h킷
//		honHead[4] = htonl(0x444b5700);				// |󃂁[h킷iłE܂j


		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕

//		theSocket.Send(honHead, int32Length * 2 + honDataLength, 0);

		theSocket.Send(honHead, int32Length * 4, 0);
		theSocket.Send(theCHonyakuSet.EinichiSet);
		short FinalSendChar = NULL;  
		theSocket.Send(&FinalSendChar, 1, 0);


		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");				
#if 0
			AfxMessageBox("3");
#endif
			HonDisconnect();
			return; // IɂẮAōl
		}

		if (ntohl(honHead[2]) != 0)
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));
#if 0
			AfxMessageBox("4");
#endif			
			HonDisconnect();
			return;
		}


		//// eg_setsetdictname(0x00f0001)  |Ɏgp鎫̐ݒ
		// i[hσo[Wj

		// [U̎擾

		userNameLength = 100;
		GetUserName(userName,&userNameLength);

		sendMessage = userName;

		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

//		honDataLength = int32Length * 12;			// 48

		honDataLength = 42 + sendMessage.GetLength() + 1;		


		honHead[1] = htonl(honDataLength);			// 0x00000030;

		honHead[2] = htonl(EG_SETDICTNAME);			// 0x00f00013;

		honHead[3] = htonl(EJ);						// English->Japanese

		if (theCHonyakuSet.CompDic == TRUE)
			honHead[4] = htonl(0x00000001);			// Rs[^ppꎫ̎gp
		else										// gp:1 gpȂ:0
			honHead[4] = htonl(0x00000000);	

		if (theCHonyakuSet.StudyDic == TRUE)	
			honHead[5] = htonl(0x00000001);			// 	wK̎gp
		else 										// gp:1 gpȂ:0
			honHead[5] = htonl(0x00000000);	

		INT32 DicCount = 3;
		honHead[6] = htonl(DicCount);				// gp鎫
	
		honHead[7] = htonl(0x00034343);				// ȉeӖ͕s
		honHead[8] = htonl(0x636f6d70);				// ipPbgAiCU̓ǂݎ茋ʁj
		honHead[9] = htonl(0x75746572);
		honHead[10] = htonl(0x00000053);
		honHead[11] = htonl(0x5300004c);
//		honHead[12] = htonl(0x4c4c6562);
//		honHead[13] = htonl(0x61746100);

		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕
		theSocket.Send(honHead, int32Length * 2 + int32Length * 10, 0);

		theSocket.Send("LL");

		sendMessage = userName;
		theSocket.Send(sendMessage,0,0);	//[ȖM
		theSocket.Send(&dummyByte, 1, 0);	// I[


	
		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");		
			HonDisconnect();
			return; // IɂẮAōl
		}
			
		// G[`FbN
		if (ntohl(honHead[2]) != 0)
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));		
			HonDisconnect();
			return;
		}

		// ʂ̎MiM̂݁AʂȏȂj
		if (theSocket.Receive(honHead,int32Length * DicCount, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");		
			HonDisconnect();
			return; // IɂẮAōl
		}

		//// eg_clear_cache(0x00f00014) ẽLbVNA

		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

		honDataLength = int32Length * 2;
		honHead[1] = htonl(honDataLength);			// 0x00000008

		honHead[2] = htonl(EG_CLEAR_CACHE);			// 0x00f00014
		honHead[3] = htonl(EJ);						// 0x00000001;

		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕
		theSocket.Send(honHead, int32Length * 2 + honDataLength, 0);

		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂(EJ EG_CLEAR_CACHE)B");		
#if 0
			AfxMessageBox("8");
#endif
			HonDisconnect();
			return; // IɂẮAōl
		}

		if (ntohl(honHead[2]) != 0)
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));	
#if 0
			AfxMessageBox("9");
#endif
			HonDisconnect();
			return;
		}		

		// eg_nonmode(0x00f0001c) es

		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

		honDataLength = int32Length * 4;
		honHead[1] = htonl(honDataLength);			// 0x00000010

		honHead[2] = htonl(EG_NONMODE);				// 0x00f0001c
		honHead[3] = htonl(EJ);						// 0x00000001
		honHead[4] = htonl(0x0000001e);				// es
		honHead[5] = htonl(0x0000001e);				// es

		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕
		theSocket.Send(honHead, int32Length * 2 + honDataLength, 0);

		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂(EJ EG_NONMODE)B");		
#if 0
			AfxMessageBox("10");
#endif
			HonDisconnect();
			return; // IɂẮAōl
		}

		if (ntohl(honHead[2]) != 0)
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));	
#if 0
			AfxMessageBox("11");
#endif
			HonDisconnect();
			return;
		}
	}	
		

	// trns_divide_sentence(0x00f0001b) 

	honHead[0] = htonl(SEND_ID);					// 0x02bbccdd

	honDataLength = m_srcDocumentMessage.GetLength() + int32Length * 3 + 1;
	honHead[1] = htonl(honDataLength);				
	
	honHead[2] = htonl(TRNS_DIVIDE_SENTENCE);		// 0x00f0001b
	honHead[3] = htonl(EJ);							// 0x00000001
	honHead[4] = htonl(0x00000001);					// ꂽes̐擪2oCg̏񕶎
													// (0:tȂ 1:t)

	theSocket.Send(honHead, int32Length * 5, 0); // honHead[0]-honHead[4]܂őM
	theSocket.Send(m_srcDocumentMessage,0,0);	//  p̑M

	INT32 int32Dummy = 0;
	theSocket.Send(&int32Dummy, 1, 0);		// NULL̑M

	// bZ[W̎M
	if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
	{
		AfxMessageBox("bZ[W̎MɎs܂(EJ TRNS_DIVIDE_SENTENCE)B");		
#if 0
		AfxMessageBox("12");
#endif
		HonDisconnect();
		return; // IɂẮAōl
	}
	if (ntohl(honHead[2]) != 0)
	{
		AfxMessageBox(HonyakuError(ntohl(honHead[2])));
#if 0
		AfxMessageBox("13");
#endif		
		HonDisconnect();
		return;
	}

	if (theSocket.Receive(&int32Dummy,int32Length, 0) == SOCKET_ERROR)
	{
		AfxMessageBox("bZ[W̎MɎs܂(EJ TRNS_DIVIDE_SENTENCE)B");		
#if 0
		AfxMessageBox("14");
#endif
		HonDisconnect();
		return; // IɂẮAōl
	}

	int sentenceCount = ntohl(int32Dummy);	// ̐

	CString dividedMessage;
	theSocket.Receive(dividedMessage,0,0);	// ꂽp̎M
	
	dividedMessage = dividedMessage.Mid(2);	//  ŏ̂Q 0x20 0x50 ̂Ă
											//	î߂ɂ񂾂낤Hj

	int msgEnd;
	while ( (msgEnd = dividedMessage.Find(0x0a))  > 0)
	{
		CString partSrcMessage =  dividedMessage.Left(msgEnd);
		// partSrcMessagȅ

		//// eg_translate_one(0x00f00004) ꕶ|

		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd
	
		honDataLength = partSrcMessage.GetLength() + int32Length * 6 + 1;
		honHead[1] = htonl(honDataLength);			// 

		honHead[2] = htonl(EG_TRANSLATE_ONE);		// 0x00f00004
		honHead[3] = htonl(EJ);						// 0x00000001
		honHead[4] = htonl(0);						// 0x00000000 0w
		honHead[5] = htonl(HON_BUF_SIZE);			// 0x00001000 1024w
		honHead[6] = htonl(0);						// 0x0000 0x0000 2byte02w
		honHead[7] = htonl(0);						// 0x00000000 0w

		theSocket.Send(honHead, int32Length * 8, 0); // honHead[0]-honHead[7]܂őM
		theSocket.Send(partSrcMessage, 0 ,0);	// p̑M

		if (ejShowFlag = true)						//  |󌋉ʂɌipj\
		{
			m_dstDocumentMessage += "[p]";
			m_dstDocumentMessage += partSrcMessage;
			m_dstDocumentMessage += "\r\n";
		}
		
		int32Dummy = 0;
		theSocket.Send(&int32Dummy, 1, 0);		// NULL̑M

		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂(EJ EG_TRANSLATE_ONE)B");		
#if 0
			AfxMessageBox("15");
#endif
			HonDisconnect();
			return; // IɂẮAōl
		}

		if (ntohl(honHead[2]) != 0)
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));
#if 0
			AfxMessageBox("16");
#endif			
			HonDisconnect();
			return;
		}

		// bZ[W̎M(2byte0M)

		if (theSocket.Receive(&int32Dummy, 2, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B(EJ EG_TRANSLATE_ONE)");		
#if 0
			AfxMessageBox("17");
#endif
			HonDisconnect();
			return; // IɂẮAōl
		}	

		// euc -> sjis

		BYTE dummyByte;
		bool firstByteFlag = false ; 
		
		if (ejShowFlag = true)						//  |󌋉ʂ"[]"\
		{
			m_dstDocumentMessage += "[]";
		}

		do			// |󌋉ʁi{j̑gݗ
		{
			unsigned int dummyUnsignedInt;

			if ((theSocket.Receive(&dummyByte, 1, 0) == SOCKET_ERROR))
			{
				CString strError = "Error";
				AfxMessageBox("???? Error(EJ EG_TRANSLATE_ONE)");
#if 0
				AfxMessageBox("18");
#endif
				HonDisconnect();
			}


			// ASCIIR[hȂ
			if ((dummyByte > 0x00) & (dummyByte <= 0x7f))
			{
				m_dstDocumentMessage += dummyByte;

				firstByteFlag = false;  // sv
			}
			// pȂ
			else if (dummyByte == 0x8e)
			{
				//later

				firstByteFlag = false;	// sv		
			}
			// A⏕Ȃ
			else if (dummyByte == 0x8f)
			{
				// later;

				firstByteFlag = false; // sv
			}
			else if (firstByteFlag == false)
			{
				dummyUnsignedInt = 0x00000000;
				dummyUnsignedInt = (0x000000ff & dummyByte) <<8;
				firstByteFlag = true;
			}
			else if (firstByteFlag == true)
			{
				dummyUnsignedInt |= (0x000000ff & dummyByte);
				unsigned int dummy = theTransChar.euc2sjis(dummyUnsignedInt);

				char kanji[3];

				kanji[0] = (dummy & 0x0000ff00) >> 8;
				kanji[1] = (dummy & 0x000000ff) ;
				kanji[2] = 0x00;
	
				m_dstDocumentMessage += kanji; // 

				firstByteFlag = false;
			}

		}while( dummyByte != 0x00);

		m_dstDocumentMessage += "\r\n\r\n";
		dividedMessage = dividedMessage.Mid(msgEnd+1);

		// 擪0x20 0x50ɂȂĂꍇ́A
		// 0x20 0x50̂ĂB
		CString dummyCString = dividedMessage.Left(2);
		if ( dummyCString == " P")
			dividedMessage = dividedMessage.Mid(2);
	}
		
	UpdateData(false);

	ejCounterFlag++; // pꁨ{ꏈ񐔂̃JEg

}



void WinHonMain::OnButton2() 
{
//		UpdateData(true);


	// Ȃꍇ́Ã[`I
	if (m_srcDocumentMessage.GetLength() == 0) 
	{
		AfxMessageBox("{͂Ă܂B");
#if 0
		AfxMessageBox("19");
#endif
		HonDisconnect();	
		return;
	}

	// ̉sR[h̏
	m_srcDocumentMessage = theTransChar.eraseJLineFeed(m_srcDocumentMessage);


	// ^CAEgԂ̐ݒ 10[b]
	UINT uTimeOut = 10000;

	CString sendMessage; 
	CString recvMessage;

	INT32 honHead[20];			// |󍰃wb_bZ[W͗pobt@
	memset(honHead, 0, sizeof(INT32) * 20);
	INT32 honDataLength = 0;		// |󍰃bZ[Wf[^
	INT32 int32Length = 4;		// INT32̃oCg(=4)


	// pꁨ{ϊ߂čsꍇ́A{
	if (jeCounterFlag == 0)
	{

		//// eg_init(0x00f00001) |GW̏

		// [U̎擾
		char userName[100];
		DWORD userNameLength = 100;
		GetUserName(userName,&userNameLength);
		
		sendMessage = userName;

		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

		honDataLength = int32Length * 3 + sendMessage.GetLength() + 1;

		honHead[1] = htonl(honDataLength);			// 

		honHead[2] = htonl(EG_INIT);				// 0x00f00001
		honHead[3] = htonl(JE);						// 0x00000002 Japanese->English
		honHead[4] = htonl(0x0000e001);				// dl̎w

		
		// bZ[W̑M
		// int32Length * 5 ́AhonHead[0] - honHead[4]̕
		theSocket.Send(honHead, int32Length * 5, 0);

		theSocket.Send(sendMessage,0,0);	//[ȖM
		BYTE dummyByte;
		theSocket.Send(&dummyByte, 1, 0);	// I[
		
		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");		
#if 0
			AfxMessageBox("20");
#endif
			HonDisconnect();
			return;
			// IɂẮAōl
		}

		if (ntohl(honHead[2]) != 0)
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));
#if 0
			AfxMessageBox("21");
#endif					
			HonDisconnect();	
			return;
		}
		
		//// eg_setmode(0x00f00011) |GW̃[hݒ
		// í݂A[hŒj

		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

// 		honDataLength = int32Length * 5 + 1;		// 21
		honDataLength =   int32Length * 2 
						+ theCHonyakuSet.NichieiSet.GetLength()
						+ 1 ;
		
		honHead[1] = htonl(honDataLength);			// 0x00000015

		honHead[2] = htonl(EG_SETMODE);				// 0x00f00011
		honHead[3] = htonl(JE);						// 0x00000002 Japanese->English

//		honHead[4] = htonl(0x31303131);				// |󃂁[h킷
//		honHead[5] = htonl(0x303a493a);				// |󃂁[h킷
//		honHead[6] = htonl(0x303a6974);				// |󃂁[h킷
//		honHead[7] = htonl(0x00000000);				// |󃂁[h킷

		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕
//		theSocket.Send(honHead, int32Length * 2 + honDataLength, 0);

		theSocket.Send(honHead, int32Length * 4);
		theSocket.Send(theCHonyakuSet.NichieiSet);
		short FinalSendChar = NULL;  
		theSocket.Send(&FinalSendChar, 1, 0);

		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");	
			HonDisconnect();	
			return; // IɂẮAōl
		}

		if (ntohl(honHead[2]) != 0)
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));	
			HonDisconnect();
			return;
		}

		//// eg_setsetdictname(0x00f0001)  |Ɏgp鎫̐ݒ
		// i[hσo[Wj

		// [U̎擾

		userNameLength = 100;
		GetUserName(userName,&userNameLength);

		sendMessage = userName;

		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

//		honDataLength = int32Length * 12;			// 48

		honDataLength = 42 + sendMessage.GetLength() + 1;		


		honHead[1] = htonl(honDataLength);			// 0x00000030;

		honHead[2] = htonl(EG_SETDICTNAME);			// 0x00f00013;

		honHead[3] = htonl(JE);						// Japanese->English

		if (theCHonyakuSet.CompDic == TRUE)
			honHead[4] = htonl(0x00000001);			// Rs[^ppꎫ̎gp
		else										// gp:1 gpȂ:0
			honHead[4] = htonl(0x00000000);	

		if (theCHonyakuSet.StudyDic == TRUE)	
			honHead[5] = htonl(0x00000001);			// 	wK̎gp
		else 										// gp:1 gpȂ:0
			honHead[5] = htonl(0x00000000);	

		INT32 DicCount = 3;
		honHead[6] = htonl(DicCount);				// gp鎫
	
		honHead[7] = htonl(0x00034343);				// ȉeӖ͕s
		honHead[8] = htonl(0x636f6d70);				// ipPbgAiCU̓ǂݎ茋ʁj
		honHead[9] = htonl(0x75746572);
		honHead[10] = htonl(0x00000053);
		honHead[11] = htonl(0x5300004c);
//		honHead[12] = htonl(0x4c4c6562);
//		honHead[13] = htonl(0x61746100);

		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕
		theSocket.Send(honHead, int32Length * 2 + int32Length * 10, 0);

		theSocket.Send("LL");

		sendMessage = userName;
		theSocket.Send(sendMessage,0,0);	//[ȖM
		theSocket.Send(&dummyByte, 1, 0);	// I[


	
		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");		
			HonDisconnect();
			return; // IɂẮAōl
		}
			
		// G[`FbN
		if (ntohl(honHead[2]) != 0)
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));		
			HonDisconnect();
			return;
		}

		// ʂ̎MiM̂݁AʂȏȂj
		if (theSocket.Receive(honHead,int32Length * DicCount, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");		
			HonDisconnect();
			return; // IɂẮAōl
		}

		//// eg_clear_cache(0x00f00014) ẽLbVNA

		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

		honDataLength = int32Length * 2;
		honHead[1] = htonl(honDataLength);			// 0x00000008

		honHead[2] = htonl(EG_CLEAR_CACHE);			// 0x00f00014
		honHead[3] = htonl(JE);						// 0x00000002 Japanese->English

		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕
		theSocket.Send(honHead, int32Length * 2 + honDataLength, 0);

		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");		
#if 0
			AfxMessageBox("28");
#endif
			HonDisconnect();
			return; // IɂẮAōl
		}

		if (ntohl(honHead[2]) != 0)
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));	
#if 0
			AfxMessageBox("29");
#endif			
			HonDisconnect();
			return;
		}		

		// eg_nonmode(0x00f0001c) es

		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

		honDataLength = int32Length * 4;
		honHead[1] = htonl(honDataLength);			// 0x00000010

		honHead[2] = htonl(EG_NONMODE);				// 0x00f0001c
		honHead[3] = htonl(JE);						// 0x00000002 Japanese->English
		honHead[4] = htonl(0x0000001e);				// es
		honHead[5] = htonl(0x0000001e);				// es

		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕
		theSocket.Send(honHead, int32Length * 2 + honDataLength, 0);

		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");		
#if 0
			AfxMessageBox("30");
#endif			
			HonDisconnect();
			return; // IɂẮAōl
		}

		if (ntohl(honHead[2]) != 0)
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));	
#if 0
			AfxMessageBox("31");
#endif			
			HonDisconnect();
			return;
		}
	}	// pꁨ{ϊ߂čsꍇ̏I	


	// trns_divide_sentence(0x00f0001b) 

	honHead[0] = htonl(SEND_ID);					// 0x02bbccdd

	honDataLength = m_srcDocumentMessage.GetLength() + int32Length * 3 + 1;
	honHead[1] = htonl(honDataLength);				
	
	honHead[2] = htonl(TRNS_DIVIDE_SENTENCE);		// 0x00f0001b
	honHead[3] = htonl(JE);							// 0x00000001
	honHead[4] = htonl(0x00000001);					// ꂽes̐擪2oCg̏񕶎
													// (0:tȂ 1:t)

	theSocket.Send(honHead, int32Length * 5, 0); // honHead[0]-honHead[4]܂őM

	////   {̑M

	// CStringɊi[{ꃁbZ[W𕶎ƂĎo
	const char *p = (LPCTSTR)m_srcDocumentMessage;

	//// sjis->euc

	// bZ[W̕񐔂𐔂
	int charNumber = m_srcDocumentMessage.GetLength();

	for(int i = 0; i < charNumber; i++)
	{
		unsigned short dummyShort = p[i] & 0x00ff ; 

		// ASCIIR[hȂÂ܂ܑt
		if ((dummyShort >= 0x00) && (dummyShort <= 0x7f))	
		{
			theSocket.Send(&dummyShort,1,0);
		}
		// JISpJiȂ
		else if ((dummyShort >= 0xa0) && (dummyShort <= 0xdf))	
		{
			theSocket.Send(&dummyShort,1,0); // ̂܂ܑĂȂH
		}
		// JISȂ
		else if (((dummyShort >= 0x81) && (dummyShort <= 0x9f)) 
			|| ((dummyShort >= 0xe0) && (dummyShort <= 0xef)))
		{
			// ܂A{ꕶSJISR[hƂđgݗĂ(Ɨǂ͂͂j
			unsigned int hib = 0;
			unsigned int lob = 0;
			unsigned int KanjiSjisCode = 0;

			hib = ( p[i] & 0x000000ff) << 8;
			lob = p[i + 1] & 0x000000ff;
			KanjiSjisCode = ( hib | lob ) & 0x0000ffff ;

			// SJIS->EUCR[hϊ
			short KanjiEucCode = (short)theTransChar.sjis2euc(KanjiSjisCode);
		
			// lbg[NoCgI[_ɕϊ
			KanjiEucCode = htons(KanjiEucCode);

			// {ꕶM
			theSocket.Send(&KanjiEucCode, 2, 0);

			i++;  // ̃CNg؁I
		}
	}

	// Ō̈ꕶM
	short FinalSendChar = NULL;  
	theSocket.Send(&FinalSendChar, 1, 0);

	// i{jM


	////  ܂񂾌i{jMJniAeucR[ĥ܂܎Mj
	// bZ[W̎M
	if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
	{
		AfxMessageBox("bZ[W̎MɎs܂B");	
#if 0
		AfxMessageBox("32");
#endif					
		HonDisconnect();
		return; // IɂẮAōl
	}
	if (ntohl(honHead[2]) != 0)
	{
		AfxMessageBox(HonyakuError(ntohl(honHead[2])));	
#if 0
		AfxMessageBox("33");
#endif			
		HonDisconnect();
		return;
	}

	INT32 int32Dummy;

	if (theSocket.Receive(&int32Dummy,int32Length, 0) == SOCKET_ERROR)
	{
		AfxMessageBox("bZ[W̎MɎs܂B");		
#if 0
		AfxMessageBox("34");
#endif			
		HonDisconnect();
		return; // IɂẮAōl
	}

	int sentenceCount = ntohl(int32Dummy);	// ̐


	CString dividedMessage;
	BYTE dummyByte;

	do			// ꕶMĂB
	{
		theSocket.Receive(&dummyByte, 1, 0);
		dividedMessage += dummyByte;
	}while( dummyByte != 0x00);

	dividedMessage += 0x0a;
	
	dividedMessage = dividedMessage.Mid(2);	//  ŏ̂Q 0x20 0x50 ̂Ă
											//	î߂ɂ񂾂낤Hj

	///// ̓{𕡐ɕđÂǉp𓾂B
	int msgEnd;

	while ( (msgEnd = dividedMessage.Find(0x0a))  > 0)
	{
		CString partSrcMessage =  dividedMessage.Left(msgEnd);

		// partSrcMessagȅ

		//// eg_translate_one(0x00f00004) ꕶ|	
		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

		honDataLength = partSrcMessage.GetLength() + int32Length * 6 + 1;
													// honHead[2]-honHead[7] + ŌNULLM
		honHead[1] = htonl(honDataLength);			// 

		honHead[2] = htonl(EG_TRANSLATE_ONE);		// 0x00f00004
		honHead[3] = htonl(JE);						// 0x00000002
		honHead[4] = htonl(0);						// 0x00000000 0w
		honHead[5] = htonl(HON_BUF_SIZE);			// 0x00001000 1024w
		honHead[6] = htonl(0);						// 0x0000 0x0000 2byte02w
		honHead[7] = htonl(0);						// 0x00000000 0w

		theSocket.Send(honHead, int32Length * 8, 0); // honHead[0]-honHead[7]܂őM
		theSocket.Send(partSrcMessage, 0, 0);

		m_dstDocumentMessage += "[]";
		m_dstDocumentMessage += theTransChar.euc2sjis(partSrcMessage);
		m_dstDocumentMessage += "\r\n";
		m_dstDocumentMessage += "[p]";

		// Ō̈ꕶM
		short FinalSendChar = NULL;  
		theSocket.Send(&FinalSendChar, 1, 0);

		// ŏ12oCgMAG[R[h`FbN
		if ((theSocket.Receive(honHead, 12, 0) == SOCKET_ERROR) || (ntohl(honHead[2]) != 0))
		{
			AfxMessageBox(HonyakuError(ntohl(honHead[2])));
#if 0
			AfxMessageBox("35");
#endif				
			HonDisconnect();		
			return;
		}

		// 2oCg0M 
		short s_dummy;
		theSocket.Receive(&s_dummy, 2, 0) ;

		// |σbZ[W܂Ƃ߂ĎM
		// oCgI[_̕ϊ͉L\bhɊ܂܂Ăi͂j
		CString partDstMessage;
		theSocket.Receive(partDstMessage,0,0);

		partDstMessage += "\r\n";
		m_dstDocumentMessage += partDstMessage;
		m_dstDocumentMessage += "\r\n";

		dividedMessage = dividedMessage.Mid(msgEnd+1);

		// 擪0x20 0x50ɂȂĂꍇ́A
		// 0x20 0x50̂ĂB
		CString dummyCString = dividedMessage.Left(2);
		if ( dummyCString == " P")
			dividedMessage = dividedMessage.Mid(2);
	}

	// i{jM

	m_dstDocumentMessage +="\r\n";

	UpdateData(false);

	jeCounterFlag++;
}

void WinHonMain::OnChangeEdit2() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	

	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
}

void WinHonMain::OnOK() 
{
	INT32 honHead[20];			// |󍰃wb_bZ[W͗pobt@
	memset(honHead, 0, sizeof(INT32) * 20);
	INT32 honDataLength = 0;	// |󍰃bZ[Wf[^
	INT32 int32Length = 4;		// INT32̃oCg(=4)	

	if (jeCounterFlag != 0) // JE[hȏg
	{
		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

		honDataLength = int32Length * 2;
		honHead[1] = htonl(honDataLength);			// 0x00000008
		honHead[2] = htonl(EG_END);					// 0x00f00002
		honHead[3] = htonl(JE);						// 0x00000002 Japanese->English

		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕
		theSocket.Send(honHead, int32Length * 2 + honDataLength, 0);

		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");		
			return; // IɂẮAōl
		}
	}

	if (ejCounterFlag != 0)  // EJ[hȏg
	{
		honHead[0] = htonl(SEND_ID);				// 0x02bbccdd

		honDataLength = int32Length * 2;
		honHead[1] = htonl(honDataLength);			// 0x00000008
		honHead[2] = htonl(EG_END);					// 0x00f00002
		honHead[3] = htonl(EJ);						// 0x00000001 English->Japanese

		// bZ[W̑M
		// int32Length * 2 ́AhonHead[0],honHead[1]̕
		theSocket.Send(honHead, int32Length * 2 + honDataLength, 0);

		// bZ[W̎M
		if (theSocket.Receive(honHead,int32Length * 3, 0) == SOCKET_ERROR)
		{
			AfxMessageBox("bZ[W̎MɎs܂B");		
			return; // IɂẮAōl
		}
	}

	
	CDialog::OnOK();
}

void WinHonMain::OnButton3() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_srcDocumentMessage.Empty();
	m_dstDocumentMessage.Empty();
	UpdateData(false);
}

void WinHonMain::OnChangeEdit1() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
}

void WinHonMain::OnButton4() 
{
	if (theSocket.m_licence == TRUE)	// CZXߖ񃂁[h̏ꍇ́A
	{
		honyakuTimerCouter = 0;			// ^C}JEgZbg
		SetTimer(1, 1000, NULL);		// ^C}Zbg
	}

	m_korekkiriButton.EnableWindow(false);
	AfxGetApp()->DoWaitCursor(1);

	UpdateData(true);

	// Ȃꍇ́Ã[`I
	if (m_srcDocumentMessage.GetLength() == 0) 
	{
		AfxMessageBox("͂Ă܂B");	
		m_korekkiriButton.EnableWindow(true);
		return;
	}

	m_dstDocumentMessage.Empty();


	// ̏̓RlNVmsAڂ́A
	// T[o̓_CAOŎ{̂ŁAʂȂ
	if ((realInitFlag == FALSE) && (passedOnTimerFlag == TRUE))
	{
		passedOnTimerFlag = FALSE;
		if (!theSocket.Create())
		{
			AfxMessageBox("\Pbg쐬ł܂łB");
			m_korekkiriButton.EnableWindow(true);
			return; // IɂẮAōl
		}
		
		// RlNVm
		if (!theSocket.Connect(theSocket.m_HonyakuServer, 2744))
		{
			AfxMessageBox("T[oւ̃RlNVɎs܂B");
			m_korekkiriButton.EnableWindow(true);
			return; // IɂẮAōl
		}
	}
	
	realInitFlag = FALSE;  // ڂȂ


	if (theTransChar.isSjisKanji(m_srcDocumentMessage))
		WinHonMain::OnButton2() ;
	else
		WinHonMain::OnButton1() ;

	AfxGetApp()->DoWaitCursor(-1);
	m_korekkiriButton.EnableWindow(true);
}



void WinHonMain::OnTimer(UINT nIDEvent) 
{
	honyakuTimerCouter++;

	if (honyakuTimerCouter >= 180) // 180bo
	{
		KillTimer(1); // ^C}Cxg̔s~

	// 	HonDisconnect();
	
		m_srcDocumentMessage.Empty();
		m_dstDocumentMessage = "CZXߖ񃂁[hɓ܂B\r\n";
		UpdateData(false);	

		HonDisconnect();
	}	

	CDialog::OnTimer(nIDEvent);
}

